#!/bin/bash

DMCSPATH='/usr/local/dmcs/dmcs-df/src'
RUNPATH='/usr/local/dmcs/dmcs-df/src'
RUNTIME='180'
RUNREALTIME='180'
RUNSPACE='2024'

COUNTER=0
while [[ `ps ax | grep dm[c]sd]` && $COUNTER -lt 100 ]]
do
	killall dmcsd
	sleep 0.1
	let COUNTER=COUNTER+1
done

$RUNPATH/run -o log/dmcs-df-opt-1.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=1 --port=5001 --kb=./kb/mcs-1.lp --br=./kb/mcs-1.br --topology=./kb/mcs.opt $* > ./log/dmcs-df-opt-1.log 2> ./log/dmcs-df-opt-1.err.log &
$RUNPATH/run -o log/dmcs-df-opt-2.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=2 --port=5002 --kb=./kb/mcs-2.lp --br=./kb/mcs-2.br --topology=./kb/mcs.opt $* > ./log/dmcs-df-opt-2.log 2> ./log/dmcs-df-opt-2.err.log &
$RUNPATH/run -o log/dmcs-df-opt-3.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=3 --port=5003 --kb=./kb/mcs-3.lp --br=./kb/mcs-3.br --topology=./kb/mcs.opt $* > ./log/dmcs-df-opt-3.log 2> ./log/dmcs-df-opt-3.err.log &
$RUNPATH/run -o log/dmcs-df-opt-4.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=4 --port=5004 --kb=./kb/mcs-4.lp --br=./kb/mcs-4.br --topology=./kb/mcs.opt $* > ./log/dmcs-df-opt-4.log 2> ./log/dmcs-df-opt-4.err.log &

COUNTER=0
while [[ $COUNTER -lt 50 && ! ( `grep request ./log/dmcs-df-opt-1.log` && `grep request ./log/dmcs-df-opt-2.log` && `grep request ./log/dmcs-df-opt-3.log` && `grep request ./log/dmcs-df-opt-4.log` ) ]]
do
	sleep 0.1
	let COUNTER=COUNTER+1
done

if [ $COUNTER -lt 50 ]
then
	$RUNPATH/run -o log/dmcs-df-opt.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME  time -o log/dmcs-df-opt.time.log -p $DMCSPATH/dmcsc --hostname=localhost --port=5001 --system-size=4 --manager=./kb/mcs.opt --diagnoses=true $* > ./log/dmcs-df-opt.log 2> ./log/dmcs-df-opt.err.log
fi

killall dmcsd
