#!/bin/bash

DMCSPATH='/usr/local/dmcs/dmcs-df/src'
RUNPATH='/usr/local/dmcs/dmcs-df/src'
RUNTIME='180'
RUNREALTIME='180'
RUNSPACE='2024'

COUNTER=0
while [[ `ps ax | grep dm[c]sd]` && $COUNTER -lt 100 ]]
do
	killall dmcsd
	sleep 0.1
	let COUNTER=COUNTER+1
done

$RUNPATH/run -o log/dmcs-1.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=1 --port=5001 --kb=./kb/mcs-1.lp --br=./kb/mcs-1.br --topology=./kb/mcs.top $* > ./log/dmcs-1.log 2> ./log/dmcs-1.err.log &
$RUNPATH/run -o log/dmcs-2.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=2 --port=5002 --kb=./kb/mcs-2.lp --br=./kb/mcs-2.br --topology=./kb/mcs.top $* > ./log/dmcs-2.log 2> ./log/dmcs-2.err.log &
$RUNPATH/run -o log/dmcs-3.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=3 --port=5003 --kb=./kb/mcs-3.lp --br=./kb/mcs-3.br --topology=./kb/mcs.top $* > ./log/dmcs-3.log 2> ./log/dmcs-3.err.log &
$RUNPATH/run -o log/dmcs-4.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=4 --port=5004 --kb=./kb/mcs-4.lp --br=./kb/mcs-4.br --topology=./kb/mcs.top $* > ./log/dmcs-4.log 2> ./log/dmcs-4.err.log &
$RUNPATH/run -o log/dmcs-5.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=5 --port=5005 --kb=./kb/mcs-5.lp --br=./kb/mcs-5.br --topology=./kb/mcs.top $* > ./log/dmcs-5.log 2> ./log/dmcs-5.err.log &
$RUNPATH/run -o log/dmcs-6.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=6 --port=5006 --kb=./kb/mcs-6.lp --br=./kb/mcs-6.br --topology=./kb/mcs.top $* > ./log/dmcs-6.log 2> ./log/dmcs-6.err.log &
$RUNPATH/run -o log/dmcs-7.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=7 --port=5007 --kb=./kb/mcs-7.lp --br=./kb/mcs-7.br --topology=./kb/mcs.top $* > ./log/dmcs-7.log 2> ./log/dmcs-7.err.log &
$RUNPATH/run -o log/dmcs-8.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=8 --port=5008 --kb=./kb/mcs-8.lp --br=./kb/mcs-8.br --topology=./kb/mcs.top $* > ./log/dmcs-8.log 2> ./log/dmcs-8.err.log &
$RUNPATH/run -o log/dmcs-9.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME $DMCSPATH/dmcsd --context=9 --port=5009 --kb=./kb/mcs-9.lp --br=./kb/mcs-9.br --topology=./kb/mcs.top $* > ./log/dmcs-9.log 2> ./log/dmcs-9.err.log &

COUNTER=0
while [[ $COUNTER -lt 50 && ! ( `grep request ./log/dmcs-1.log` && `grep request ./log/dmcs-2.log` && `grep request ./log/dmcs-3.log` && `grep request ./log/dmcs-4.log` && `grep request ./log/dmcs-5.log` && `grep request ./log/dmcs-6.log` && `grep request ./log/dmcs-7.log` && `grep request ./log/dmcs-8.log` && `grep request ./log/dmcs-9.log` ) ]]
do
	sleep 0.1
	let COUNTER=COUNTER+1
done

if [ $COUNTER -lt 50 ]
then
	$RUNPATH/run -o log/dmcs.run.log -s $RUNSPACE -t $RUNTIME -r $RUNREALTIME  time -o log/dmcs.time.log -p $DMCSPATH/dmcsc --hostname=localhost --port=5001 --system-size=9 --manager=./kb/mcs.top --diagnoses=false --query-variables="18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615 18446744073709551615" $* > ./log/dmcs.log 2> ./log/dmcs.err.log
fi

killall dmcsd
